diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/lte/model/a2-a4-rsrq-handover-algorithm.h ns-3.41/src/lte/model/a2-a4-rsrq-handover-algorithm.h
--- ns-3.40/src/lte/model/a2-a4-rsrq-handover-algorithm.h	2023-09-27 13:30:37.706839300 -0700
+++ ns-3.41/src/lte/model/a2-a4-rsrq-handover-algorithm.h	2024-02-09 14:44:08.009791000 -0800
@@ -16,12 +16,12 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
  * Original work authors (from lte-enb-rrc.cc):
- * - Nicola Baldo <nbaldo@cttc.es>
- * - Marco Miozzo <mmiozzo@cttc.es>
- * - Manuel Requena <manuel.requena@cttc.es>
+ *   Nicola Baldo <nbaldo@cttc.es>
+ *   Marco Miozzo <mmiozzo@cttc.es>
+ *   Manuel Requena <manuel.requena@cttc.es>
  *
  * Converted to handover algorithm interface by:
- * - Budiarto Herman <budiarto.herman@magister.fi>
+ *   Budiarto Herman <budiarto.herman@magister.fi>
  */
 
 #ifndef A2_A4_RSRQ_HANDOVER_ALGORITHM_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/lte/model/cqa-ff-mac-scheduler.cc ns-3.41/src/lte/model/cqa-ff-mac-scheduler.cc
--- ns-3.40/src/lte/model/cqa-ff-mac-scheduler.cc	2023-09-27 13:30:37.706839300 -0700
+++ ns-3.41/src/lte/model/cqa-ff-mac-scheduler.cc	2024-02-09 14:44:08.013790800 -0800
@@ -256,31 +256,25 @@
         m_dlHarqCurrentProcessId.insert(std::pair<uint16_t, uint8_t>(params.m_rnti, 0));
         DlHarqProcessesStatus_t dlHarqPrcStatus;
         dlHarqPrcStatus.resize(8, 0);
-        m_dlHarqProcessesStatus.insert(
-            std::pair<uint16_t, DlHarqProcessesStatus_t>(params.m_rnti, dlHarqPrcStatus));
+        m_dlHarqProcessesStatus[params.m_rnti] = dlHarqPrcStatus;
         DlHarqProcessesTimer_t dlHarqProcessesTimer;
         dlHarqProcessesTimer.resize(8, 0);
-        m_dlHarqProcessesTimer.insert(
-            std::pair<uint16_t, DlHarqProcessesTimer_t>(params.m_rnti, dlHarqProcessesTimer));
+        m_dlHarqProcessesTimer[params.m_rnti] = dlHarqProcessesTimer;
         DlHarqProcessesDciBuffer_t dlHarqdci;
         dlHarqdci.resize(8);
-        m_dlHarqProcessesDciBuffer.insert(
-            std::pair<uint16_t, DlHarqProcessesDciBuffer_t>(params.m_rnti, dlHarqdci));
+        m_dlHarqProcessesDciBuffer[params.m_rnti] = dlHarqdci;
         DlHarqRlcPduListBuffer_t dlHarqRlcPdu;
         dlHarqRlcPdu.resize(2);
         dlHarqRlcPdu.at(0).resize(8);
         dlHarqRlcPdu.at(1).resize(8);
-        m_dlHarqProcessesRlcPduListBuffer.insert(
-            std::pair<uint16_t, DlHarqRlcPduListBuffer_t>(params.m_rnti, dlHarqRlcPdu));
+        m_dlHarqProcessesRlcPduListBuffer[params.m_rnti] = dlHarqRlcPdu;
         m_ulHarqCurrentProcessId.insert(std::pair<uint16_t, uint8_t>(params.m_rnti, 0));
         UlHarqProcessesStatus_t ulHarqPrcStatus;
         ulHarqPrcStatus.resize(8, 0);
-        m_ulHarqProcessesStatus.insert(
-            std::pair<uint16_t, UlHarqProcessesStatus_t>(params.m_rnti, ulHarqPrcStatus));
+        m_ulHarqProcessesStatus[params.m_rnti] = ulHarqPrcStatus;
         UlHarqProcessesDciBuffer_t ulHarqdci;
         ulHarqdci.resize(8);
-        m_ulHarqProcessesDciBuffer.insert(
-            std::pair<uint16_t, UlHarqProcessesDciBuffer_t>(params.m_rnti, ulHarqdci));
+        m_ulHarqProcessesDciBuffer[params.m_rnti] = ulHarqdci;
     }
     else
     {
@@ -478,9 +472,7 @@
 
     if (it == m_rlcBufferReq.end())
     {
-        m_rlcBufferReq.insert(
-            std::pair<LteFlowId_t, FfMacSchedSapProvider::SchedDlRlcBufferReqParameters>(flow,
-                                                                                         params));
+        m_rlcBufferReq[flow] = params;
     }
     else
     {
@@ -511,11 +503,11 @@
     {
         if (dlbandwidth < CqaType0AllocationRbg[i])
         {
-            return (i + 1);
+            return i + 1;
         }
     }
 
-    return (-1);
+    return -1;
 }
 
 unsigned int
@@ -535,7 +527,7 @@
             break;
         }
     }
-    return (lcActive);
+    return lcActive;
 }
 
 bool
@@ -569,7 +561,7 @@
 
     if (!m_harqOn)
     {
-        return (0);
+        return 0;
     }
 
     auto it = m_dlHarqCurrentProcessId.find(rnti);
@@ -598,7 +590,7 @@
                        << rnti << " check before update with HarqProcessAvailability");
     }
 
-    return ((*it).second);
+    return (*it).second;
 }
 
 void
@@ -1758,9 +1750,8 @@
             if (it == m_p10CqiRxed.end())
             {
                 // create the new entry
-                m_p10CqiRxed.insert(std::pair<uint16_t, uint8_t>(
-                    rnti,
-                    params.m_cqiList.at(i).m_wbCqi.at(0))); // only codeword 0 at this stage (SISO)
+                m_p10CqiRxed[rnti] =
+                    params.m_cqiList.at(i).m_wbCqi.at(0); // only codeword 0 at this stage (SISO)
                 // generate correspondent timer
                 m_p10CqiTimers.insert(std::pair<uint16_t, uint32_t>(rnti, m_cqiTimersThreshold));
             }
@@ -1781,9 +1772,7 @@
             if (it == m_a30CqiRxed.end())
             {
                 // create the new entry
-                m_a30CqiRxed.insert(
-                    std::pair<uint16_t, SbMeasResult_s>(rnti,
-                                                        params.m_cqiList.at(i).m_sbMeasResult));
+                m_a30CqiRxed[rnti] = params.m_cqiList.at(i).m_sbMeasResult;
                 m_a30CqiTimers.insert(std::pair<uint16_t, uint32_t>(rnti, m_cqiTimersThreshold));
             }
             else
@@ -1808,7 +1797,7 @@
     if (itCqi == m_ueCqi.end())
     {
         // no cqi info about this UE
-        return (NO_SINR);
+        return NO_SINR;
     }
     else
     {
@@ -1827,7 +1816,7 @@
         double estimatedSinr = (sinrNum > 0) ? (sinrSum / sinrNum) : DBL_MAX;
         // store the value
         (*itCqi).second.at(rb) = estimatedSinr;
-        return (estimatedSinr);
+        return estimatedSinr;
     }
 }
 
@@ -1974,8 +1963,7 @@
     {
         if (!ret.m_dciList.empty())
         {
-            m_allocationMaps.insert(
-                std::pair<uint16_t, std::vector<uint16_t>>(params.m_sfnSf, rbgAllocationMap));
+            m_allocationMaps[params.m_sfnSf] = rbgAllocationMap;
             m_schedSapUser->SchedUlConfigInd(ret);
         }
 
@@ -2104,8 +2092,7 @@
             //            {
             //              m_schedSapUser->SchedUlConfigInd (ret);
             //            }
-            //          m_allocationMaps.insert (std::pair <uint16_t, std::vector <uint16_t> >
-            //          (params.m_sfnSf, rbgAllocationMap)); return;
+            //          m_allocationMaps[params.m_sfnSf] = rbgAllocationMap; return;
             break;
         }
 
@@ -2248,8 +2235,7 @@
         NS_LOG_INFO(this << " UE average throughput " << (*itStats).second.lastAveragedThroughput);
         (*itStats).second.lastTtiBytesTransmitted = 0;
     }
-    m_allocationMaps.insert(
-        std::pair<uint16_t, std::vector<uint16_t>>(params.m_sfnSf, rbgAllocationMap));
+    m_allocationMaps[params.m_sfnSf] = rbgAllocationMap;
     m_schedSapUser->SchedUlConfigInd(ret);
 }
 
@@ -2367,11 +2353,9 @@
                         newCqi.push_back(NO_SINR);
                     }
                 }
-                m_ueCqi.insert(
-                    std::pair<uint16_t, std::vector<double>>((*itMap).second.at(i), newCqi));
+                m_ueCqi[(*itMap).second.at(i)] = newCqi;
                 // generate correspondent timer
-                m_ueCqiTimers.insert(
-                    std::pair<uint16_t, uint32_t>((*itMap).second.at(i), m_cqiTimersThreshold));
+                m_ueCqiTimers[(*itMap).second.at(i)] = m_cqiTimersThreshold;
             }
             else
             {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/lte/model/epc-enb-application.h ns-3.41/src/lte/model/epc-enb-application.h
--- ns-3.40/src/lte/model/epc-enb-application.h	2023-09-27 13:30:37.706839300 -0700
+++ ns-3.41/src/lte/model/epc-enb-application.h	2024-02-09 14:44:08.013790800 -0800
@@ -14,8 +14,9 @@
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
- * Author: Jaume Nin <jnin@cttc.cat>
- *         Nicola Baldo <nbaldo@cttc.cat>
+ * Authors:
+ *   Jaume Nin <jnin@cttc.cat>
+ *   Nicola Baldo <nbaldo@cttc.cat>
  */
 
 #ifndef EPC_ENB_APPLICATION_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/lte/model/epc-tft.cc ns-3.41/src/lte/model/epc-tft.cc
--- ns-3.40/src/lte/model/epc-tft.cc	2023-09-27 13:30:37.706839300 -0700
+++ ns-3.41/src/lte/model/epc-tft.cc	2024-02-09 14:44:08.013790800 -0800
@@ -310,6 +310,6 @@
 {
     NS_LOG_FUNCTION(this);
     return m_filters;
-};
+}
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/lte/model/fdbet-ff-mac-scheduler.cc ns-3.41/src/lte/model/fdbet-ff-mac-scheduler.cc
--- ns-3.40/src/lte/model/fdbet-ff-mac-scheduler.cc	2023-09-27 13:30:37.814839600 -0700
+++ ns-3.41/src/lte/model/fdbet-ff-mac-scheduler.cc	2024-02-09 14:44:08.181792000 -0800
@@ -167,31 +167,25 @@
         m_dlHarqCurrentProcessId.insert(std::pair<uint16_t, uint8_t>(params.m_rnti, 0));
         DlHarqProcessesStatus_t dlHarqPrcStatus;
         dlHarqPrcStatus.resize(8, 0);
-        m_dlHarqProcessesStatus.insert(
-            std::pair<uint16_t, DlHarqProcessesStatus_t>(params.m_rnti, dlHarqPrcStatus));
+        m_dlHarqProcessesStatus[params.m_rnti] = dlHarqPrcStatus;
         DlHarqProcessesTimer_t dlHarqProcessesTimer;
         dlHarqProcessesTimer.resize(8, 0);
-        m_dlHarqProcessesTimer.insert(
-            std::pair<uint16_t, DlHarqProcessesTimer_t>(params.m_rnti, dlHarqProcessesTimer));
+        m_dlHarqProcessesTimer[params.m_rnti] = dlHarqProcessesTimer;
         DlHarqProcessesDciBuffer_t dlHarqdci;
         dlHarqdci.resize(8);
-        m_dlHarqProcessesDciBuffer.insert(
-            std::pair<uint16_t, DlHarqProcessesDciBuffer_t>(params.m_rnti, dlHarqdci));
+        m_dlHarqProcessesDciBuffer[params.m_rnti] = dlHarqdci;
         DlHarqRlcPduListBuffer_t dlHarqRlcPdu;
         dlHarqRlcPdu.resize(2);
         dlHarqRlcPdu.at(0).resize(8);
         dlHarqRlcPdu.at(1).resize(8);
-        m_dlHarqProcessesRlcPduListBuffer.insert(
-            std::pair<uint16_t, DlHarqRlcPduListBuffer_t>(params.m_rnti, dlHarqRlcPdu));
+        m_dlHarqProcessesRlcPduListBuffer[params.m_rnti] = dlHarqRlcPdu;
         m_ulHarqCurrentProcessId.insert(std::pair<uint16_t, uint8_t>(params.m_rnti, 0));
         UlHarqProcessesStatus_t ulHarqPrcStatus;
         ulHarqPrcStatus.resize(8, 0);
-        m_ulHarqProcessesStatus.insert(
-            std::pair<uint16_t, UlHarqProcessesStatus_t>(params.m_rnti, ulHarqPrcStatus));
+        m_ulHarqProcessesStatus[params.m_rnti] = ulHarqPrcStatus;
         UlHarqProcessesDciBuffer_t ulHarqdci;
         ulHarqdci.resize(8);
-        m_ulHarqProcessesDciBuffer.insert(
-            std::pair<uint16_t, UlHarqProcessesDciBuffer_t>(params.m_rnti, ulHarqdci));
+        m_ulHarqProcessesDciBuffer[params.m_rnti] = ulHarqdci;
     }
     else
     {
@@ -214,13 +208,13 @@
             fdbetsFlowPerf_t flowStatsDl;
             flowStatsDl.flowStart = Simulator::Now();
             flowStatsDl.totalBytesTransmitted = 0;
-            flowStatsDl.lastTtiBytesTrasmitted = 0;
+            flowStatsDl.lastTtiBytesTransmitted = 0;
             flowStatsDl.lastAveragedThroughput = 1;
             m_flowStatsDl.insert(std::pair<uint16_t, fdbetsFlowPerf_t>(params.m_rnti, flowStatsDl));
             fdbetsFlowPerf_t flowStatsUl;
             flowStatsUl.flowStart = Simulator::Now();
             flowStatsUl.totalBytesTransmitted = 0;
-            flowStatsUl.lastTtiBytesTrasmitted = 0;
+            flowStatsUl.lastTtiBytesTransmitted = 0;
             flowStatsUl.lastAveragedThroughput = 1;
             m_flowStatsUl.insert(std::pair<uint16_t, fdbetsFlowPerf_t>(params.m_rnti, flowStatsUl));
         }
@@ -303,9 +297,7 @@
 
     if (it == m_rlcBufferReq.end())
     {
-        m_rlcBufferReq.insert(
-            std::pair<LteFlowId_t, FfMacSchedSapProvider::SchedDlRlcBufferReqParameters>(flow,
-                                                                                         params));
+        m_rlcBufferReq[flow] = params;
     }
     else
     {
@@ -336,11 +328,11 @@
     {
         if (dlbandwidth < FdBetType0AllocationRbg[i])
         {
-            return (i + 1);
+            return i + 1;
         }
     }
 
-    return (-1);
+    return -1;
 }
 
 unsigned int
@@ -360,7 +352,7 @@
             break;
         }
     }
-    return (lcActive);
+    return lcActive;
 }
 
 bool
@@ -394,7 +386,7 @@
 
     if (!m_harqOn)
     {
-        return (0);
+        return 0;
     }
 
     auto it = m_dlHarqCurrentProcessId.find(rnti);
@@ -423,7 +415,7 @@
                        << rnti << " check before update with HarqProcessAvailability");
     }
 
-    return ((*it).second);
+    return (*it).second;
 }
 
 void
@@ -950,8 +942,7 @@
                 if (itMap == allocationMap.end())
                 {
                     tempMap.push_back(i);
-                    allocationMap.insert(
-                        std::pair<uint16_t, std::vector<uint16_t>>((*itMax).first, tempMap));
+                    allocationMap[(*itMax).first] = tempMap;
                 }
                 else
                 {
@@ -1023,7 +1014,7 @@
     // reset TTI stats of users
     for (auto itStats = m_flowStatsDl.begin(); itStats != m_flowStatsDl.end(); itStats++)
     {
-        (*itStats).second.lastTtiBytesTrasmitted = 0;
+        (*itStats).second.lastTtiBytesTransmitted = 0;
     }
 
     // generate the transmission opportunities by grouping the RBGs of the same RNTI and
@@ -1158,8 +1149,8 @@
         auto it = m_flowStatsDl.find((*itMap).first);
         if (it != m_flowStatsDl.end())
         {
-            (*it).second.lastTtiBytesTrasmitted = bytesTxed;
-            NS_LOG_INFO(this << " UE total bytes txed " << (*it).second.lastTtiBytesTrasmitted);
+            (*it).second.lastTtiBytesTransmitted = bytesTxed;
+            NS_LOG_INFO(this << " UE total bytes txed " << (*it).second.lastTtiBytesTransmitted);
         }
         else
         {
@@ -1174,15 +1165,15 @@
     NS_LOG_INFO(this << " Update UEs statistics");
     for (auto itStats = m_flowStatsDl.begin(); itStats != m_flowStatsDl.end(); itStats++)
     {
-        (*itStats).second.totalBytesTransmitted += (*itStats).second.lastTtiBytesTrasmitted;
+        (*itStats).second.totalBytesTransmitted += (*itStats).second.lastTtiBytesTransmitted;
         // update average throughput (see eq. 12.3 of Sec 12.3.1.2 of LTE – The UMTS Long Term
         // Evolution, Ed Wiley)
         (*itStats).second.lastAveragedThroughput =
             ((1.0 - (1.0 / m_timeWindow)) * (*itStats).second.lastAveragedThroughput) +
-            ((1.0 / m_timeWindow) * (double)((*itStats).second.lastTtiBytesTrasmitted / 0.001));
+            ((1.0 / m_timeWindow) * (double)((*itStats).second.lastTtiBytesTransmitted / 0.001));
         NS_LOG_INFO(this << " UE total bytes " << (*itStats).second.totalBytesTransmitted);
         NS_LOG_INFO(this << " UE average throughput " << (*itStats).second.lastAveragedThroughput);
-        (*itStats).second.lastTtiBytesTrasmitted = 0;
+        (*itStats).second.lastTtiBytesTransmitted = 0;
     }
 
     m_schedSapUser->SchedDlConfigInd(ret);
@@ -1214,9 +1205,8 @@
             if (it == m_p10CqiRxed.end())
             {
                 // create the new entry
-                m_p10CqiRxed.insert(std::pair<uint16_t, uint8_t>(
-                    rnti,
-                    params.m_cqiList.at(i).m_wbCqi.at(0))); // only codeword 0 at this stage (SISO)
+                m_p10CqiRxed[rnti] =
+                    params.m_cqiList.at(i).m_wbCqi.at(0); // only codeword 0 at this stage (SISO)
                 // generate correspondent timer
                 m_p10CqiTimers.insert(std::pair<uint16_t, uint32_t>(rnti, m_cqiTimersThreshold));
             }
@@ -1237,9 +1227,7 @@
             if (it == m_a30CqiRxed.end())
             {
                 // create the new entry
-                m_a30CqiRxed.insert(
-                    std::pair<uint16_t, SbMeasResult_s>(rnti,
-                                                        params.m_cqiList.at(i).m_sbMeasResult));
+                m_a30CqiRxed[rnti] = params.m_cqiList.at(i).m_sbMeasResult;
                 m_a30CqiTimers.insert(std::pair<uint16_t, uint32_t>(rnti, m_cqiTimersThreshold));
             }
             else
@@ -1264,7 +1252,7 @@
     if (itCqi == m_ueCqi.end())
     {
         // no cqi info about this UE
-        return (NO_SINR);
+        return NO_SINR;
     }
     else
     {
@@ -1283,7 +1271,7 @@
         double estimatedSinr = (sinrNum > 0) ? (sinrSum / sinrNum) : DBL_MAX;
         // store the value
         (*itCqi).second.at(rb) = estimatedSinr;
-        return (estimatedSinr);
+        return estimatedSinr;
     }
 }
 
@@ -1412,8 +1400,7 @@
     {
         if (!ret.m_dciList.empty())
         {
-            m_allocationMaps.insert(
-                std::pair<uint16_t, std::vector<uint16_t>>(params.m_sfnSf, rbgAllocationMap));
+            m_allocationMaps[params.m_sfnSf] = rbgAllocationMap;
             m_schedSapUser->SchedUlConfigInd(ret);
         }
 
@@ -1531,8 +1518,7 @@
             {
                 m_schedSapUser->SchedUlConfigInd(ret);
             }
-            m_allocationMaps.insert(
-                std::pair<uint16_t, std::vector<uint16_t>>(params.m_sfnSf, rbgAllocationMap));
+            m_allocationMaps[params.m_sfnSf] = rbgAllocationMap;
             return;
         }
 
@@ -1640,7 +1626,7 @@
         auto itStats = m_flowStatsUl.find((*it).first);
         if (itStats != m_flowStatsUl.end())
         {
-            (*itStats).second.lastTtiBytesTrasmitted = uldci.m_tbSize;
+            (*itStats).second.lastTtiBytesTransmitted = uldci.m_tbSize;
         }
         else
         {
@@ -1665,18 +1651,17 @@
     // update UEs stats
     for (auto itStats = m_flowStatsUl.begin(); itStats != m_flowStatsUl.end(); itStats++)
     {
-        (*itStats).second.totalBytesTransmitted += (*itStats).second.lastTtiBytesTrasmitted;
+        (*itStats).second.totalBytesTransmitted += (*itStats).second.lastTtiBytesTransmitted;
         // update average throughput (see eq. 12.3 of Sec 12.3.1.2 of LTE – The UMTS Long Term
         // Evolution, Ed Wiley)
         (*itStats).second.lastAveragedThroughput =
             ((1.0 - (1.0 / m_timeWindow)) * (*itStats).second.lastAveragedThroughput) +
-            ((1.0 / m_timeWindow) * (double)((*itStats).second.lastTtiBytesTrasmitted / 0.001));
+            ((1.0 / m_timeWindow) * (double)((*itStats).second.lastTtiBytesTransmitted / 0.001));
         NS_LOG_INFO(this << " UE total bytes " << (*itStats).second.totalBytesTransmitted);
         NS_LOG_INFO(this << " UE average throughput " << (*itStats).second.lastAveragedThroughput);
-        (*itStats).second.lastTtiBytesTrasmitted = 0;
+        (*itStats).second.lastTtiBytesTransmitted = 0;
     }
-    m_allocationMaps.insert(
-        std::pair<uint16_t, std::vector<uint16_t>>(params.m_sfnSf, rbgAllocationMap));
+    m_allocationMaps[params.m_sfnSf] = rbgAllocationMap;
     m_schedSapUser->SchedUlConfigInd(ret);
 }
 
@@ -1794,11 +1779,9 @@
                         newCqi.push_back(NO_SINR);
                     }
                 }
-                m_ueCqi.insert(
-                    std::pair<uint16_t, std::vector<double>>((*itMap).second.at(i), newCqi));
+                m_ueCqi[(*itMap).second.at(i)] = newCqi;
                 // generate correspondent timer
-                m_ueCqiTimers.insert(
-                    std::pair<uint16_t, uint32_t>((*itMap).second.at(i), m_cqiTimersThreshold));
+                m_ueCqiTimers[(*itMap).second.at(i)] = m_cqiTimersThreshold;
             }
             else
             {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/lte/model/fdbet-ff-mac-scheduler.h ns-3.41/src/lte/model/fdbet-ff-mac-scheduler.h
--- ns-3.40/src/lte/model/fdbet-ff-mac-scheduler.h	2023-09-27 13:30:37.814839600 -0700
+++ ns-3.41/src/lte/model/fdbet-ff-mac-scheduler.h	2024-02-09 14:44:08.181792000 -0800
@@ -39,10 +39,10 @@
 /// fdbetsFlowPerf_t structure
 struct fdbetsFlowPerf_t
 {
-    Time flowStart;                      ///< flow start time
-    unsigned long totalBytesTransmitted; ///< total bytes transmitted
-    unsigned int lastTtiBytesTrasmitted; ///< last total bytes transmitted
-    double lastAveragedThroughput;       ///< last averaged throughput
+    Time flowStart;                       ///< flow start time
+    unsigned long totalBytesTransmitted;  ///< total bytes transmitted
+    unsigned int lastTtiBytesTransmitted; ///< last total bytes transmitted
+    double lastAveragedThroughput;        ///< last averaged throughput
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/lte/model/fdmt-ff-mac-scheduler.cc ns-3.41/src/lte/model/fdmt-ff-mac-scheduler.cc
--- ns-3.40/src/lte/model/fdmt-ff-mac-scheduler.cc	2023-09-27 13:30:37.814839600 -0700
+++ ns-3.41/src/lte/model/fdmt-ff-mac-scheduler.cc	2024-02-09 14:44:08.181792000 -0800
@@ -161,36 +161,30 @@
     auto it = m_uesTxMode.find(params.m_rnti);
     if (it == m_uesTxMode.end())
     {
-        m_uesTxMode.insert(std::pair<uint16_t, double>(params.m_rnti, params.m_transmissionMode));
+        m_uesTxMode[params.m_rnti] = params.m_transmissionMode;
         // generate HARQ buffers
-        m_dlHarqCurrentProcessId.insert(std::pair<uint16_t, uint8_t>(params.m_rnti, 0));
+        m_dlHarqCurrentProcessId[params.m_rnti] = 0;
         DlHarqProcessesStatus_t dlHarqPrcStatus;
         dlHarqPrcStatus.resize(8, 0);
-        m_dlHarqProcessesStatus.insert(
-            std::pair<uint16_t, DlHarqProcessesStatus_t>(params.m_rnti, dlHarqPrcStatus));
+        m_dlHarqProcessesStatus[params.m_rnti] = dlHarqPrcStatus;
         DlHarqProcessesTimer_t dlHarqProcessesTimer;
         dlHarqProcessesTimer.resize(8, 0);
-        m_dlHarqProcessesTimer.insert(
-            std::pair<uint16_t, DlHarqProcessesTimer_t>(params.m_rnti, dlHarqProcessesTimer));
+        m_dlHarqProcessesTimer[params.m_rnti] = dlHarqProcessesTimer;
         DlHarqProcessesDciBuffer_t dlHarqdci;
         dlHarqdci.resize(8);
-        m_dlHarqProcessesDciBuffer.insert(
-            std::pair<uint16_t, DlHarqProcessesDciBuffer_t>(params.m_rnti, dlHarqdci));
+        m_dlHarqProcessesDciBuffer[params.m_rnti] = dlHarqdci;
         DlHarqRlcPduListBuffer_t dlHarqRlcPdu;
         dlHarqRlcPdu.resize(2);
         dlHarqRlcPdu.at(0).resize(8);
         dlHarqRlcPdu.at(1).resize(8);
-        m_dlHarqProcessesRlcPduListBuffer.insert(
-            std::pair<uint16_t, DlHarqRlcPduListBuffer_t>(params.m_rnti, dlHarqRlcPdu));
-        m_ulHarqCurrentProcessId.insert(std::pair<uint16_t, uint8_t>(params.m_rnti, 0));
+        m_dlHarqProcessesRlcPduListBuffer[params.m_rnti] = dlHarqRlcPdu;
+        m_ulHarqCurrentProcessId[params.m_rnti] = 0;
         UlHarqProcessesStatus_t ulHarqPrcStatus;
         ulHarqPrcStatus.resize(8, 0);
-        m_ulHarqProcessesStatus.insert(
-            std::pair<uint16_t, UlHarqProcessesStatus_t>(params.m_rnti, ulHarqPrcStatus));
+        m_ulHarqProcessesStatus[params.m_rnti] = ulHarqPrcStatus;
         UlHarqProcessesDciBuffer_t ulHarqdci;
         ulHarqdci.resize(8);
-        m_ulHarqProcessesDciBuffer.insert(
-            std::pair<uint16_t, UlHarqProcessesDciBuffer_t>(params.m_rnti, ulHarqdci));
+        m_ulHarqProcessesDciBuffer[params.m_rnti] = ulHarqdci;
     }
     else
     {
@@ -292,9 +286,7 @@
 
     if (it == m_rlcBufferReq.end())
     {
-        m_rlcBufferReq.insert(
-            std::pair<LteFlowId_t, FfMacSchedSapProvider::SchedDlRlcBufferReqParameters>(flow,
-                                                                                         params));
+        m_rlcBufferReq[flow] = params;
     }
     else
     {
@@ -325,11 +317,11 @@
     {
         if (dlbandwidth < FdMtType0AllocationRbg[i])
         {
-            return (i + 1);
+            return i + 1;
         }
     }
 
-    return (-1);
+    return -1;
 }
 
 unsigned int
@@ -349,7 +341,7 @@
             break;
         }
     }
-    return (lcActive);
+    return lcActive;
 }
 
 bool
@@ -383,7 +375,7 @@
 
     if (!m_harqOn)
     {
-        return (0);
+        return 0;
     }
 
     auto it = m_dlHarqCurrentProcessId.find(rnti);
@@ -412,7 +404,7 @@
                        << rnti << " check before update with HarqProcessAvailability");
     }
 
-    return ((*it).second);
+    return (*it).second;
 }
 
 void
@@ -868,23 +860,23 @@
             double rcqiMax = 0.0;
             for (auto it = m_flowStatsDl.begin(); it != m_flowStatsDl.end(); it++)
             {
-                auto itRnti = rntiAllocated.find((*it));
-                if ((itRnti != rntiAllocated.end()) || (!HarqProcessAvailability((*it))))
+                auto itRnti = rntiAllocated.find(*it);
+                if (itRnti != rntiAllocated.end() || !HarqProcessAvailability(*it))
                 {
                     // UE already allocated for HARQ or without HARQ process available -> drop it
                     if (itRnti != rntiAllocated.end())
                     {
                         NS_LOG_DEBUG(this << " RNTI discarded for HARQ tx" << (uint16_t)(*it));
                     }
-                    if (!HarqProcessAvailability((*it)))
+                    if (!HarqProcessAvailability(*it))
                     {
                         NS_LOG_DEBUG(this << " RNTI discarded for HARQ id" << (uint16_t)(*it));
                     }
                     continue;
                 }
 
-                auto itCqi = m_a30CqiRxed.find((*it));
-                auto itTxMode = m_uesTxMode.find((*it));
+                auto itCqi = m_a30CqiRxed.find(*it);
+                auto itTxMode = m_uesTxMode.find(*it);
                 if (itTxMode == m_uesTxMode.end())
                 {
                     NS_FATAL_ERROR("No Transmission Mode info on user " << (*it));
@@ -908,7 +900,7 @@
                 if ((cqi1 > 0) ||
                     (cqi2 > 0)) // CQI == 0 means "out of range" (see table 7.2.3-1 of 36.213)
                 {
-                    if (LcActivePerFlow((*it)) > 0)
+                    if (LcActivePerFlow(*it) > 0)
                     {
                         // this UE has data to transmit
                         double achievableRate = 0.0;
@@ -951,14 +943,13 @@
             else
             {
                 rbgMap.at(i) = true;
-                auto itMap = allocationMap.find((*itMax));
+                auto itMap = allocationMap.find(*itMax);
                 if (itMap == allocationMap.end())
                 {
                     // insert new element
                     std::vector<uint16_t> tempMap;
                     tempMap.push_back(i);
-                    allocationMap.insert(
-                        std::pair<uint16_t, std::vector<uint16_t>>((*itMax), tempMap));
+                    allocationMap[*itMax] = tempMap;
                 }
                 else
                 {
@@ -1178,11 +1169,10 @@
             if (it == m_p10CqiRxed.end())
             {
                 // create the new entry
-                m_p10CqiRxed.insert(std::pair<uint16_t, uint8_t>(
-                    rnti,
-                    params.m_cqiList.at(i).m_wbCqi.at(0))); // only codeword 0 at this stage (SISO)
+                m_p10CqiRxed[rnti] =
+                    params.m_cqiList.at(i).m_wbCqi.at(0); // only codeword 0 at this stage (SISO)
                 // generate correspondent timer
-                m_p10CqiTimers.insert(std::pair<uint16_t, uint32_t>(rnti, m_cqiTimersThreshold));
+                m_p10CqiTimers[rnti] = m_cqiTimersThreshold;
             }
             else
             {
@@ -1201,10 +1191,8 @@
             if (it == m_a30CqiRxed.end())
             {
                 // create the new entry
-                m_a30CqiRxed.insert(
-                    std::pair<uint16_t, SbMeasResult_s>(rnti,
-                                                        params.m_cqiList.at(i).m_sbMeasResult));
-                m_a30CqiTimers.insert(std::pair<uint16_t, uint32_t>(rnti, m_cqiTimersThreshold));
+                m_a30CqiRxed[rnti] = params.m_cqiList.at(i).m_sbMeasResult;
+                m_a30CqiTimers[rnti] = m_cqiTimersThreshold;
             }
             else
             {
@@ -1228,7 +1216,7 @@
     if (itCqi == m_ueCqi.end())
     {
         // no cqi info about this UE
-        return (NO_SINR);
+        return NO_SINR;
     }
     else
     {
@@ -1247,7 +1235,7 @@
         double estimatedSinr = (sinrNum > 0) ? (sinrSum / sinrNum) : DBL_MAX;
         // store the value
         (*itCqi).second.at(rb) = estimatedSinr;
-        return (estimatedSinr);
+        return estimatedSinr;
     }
 }
 
@@ -1376,8 +1364,7 @@
     {
         if (!ret.m_dciList.empty())
         {
-            m_allocationMaps.insert(
-                std::pair<uint16_t, std::vector<uint16_t>>(params.m_sfnSf, rbgAllocationMap));
+            m_allocationMaps[params.m_sfnSf] = rbgAllocationMap;
             m_schedSapUser->SchedUlConfigInd(ret);
         }
 
@@ -1495,8 +1482,7 @@
             {
                 m_schedSapUser->SchedUlConfigInd(ret);
             }
-            m_allocationMaps.insert(
-                std::pair<uint16_t, std::vector<uint16_t>>(params.m_sfnSf, rbgAllocationMap));
+            m_allocationMaps[params.m_sfnSf] = rbgAllocationMap;
             return;
         }
 
@@ -1614,8 +1600,7 @@
         }
     } while (((*it).first != m_nextRntiUl) && (rbPerFlow != 0));
 
-    m_allocationMaps.insert(
-        std::pair<uint16_t, std::vector<uint16_t>>(params.m_sfnSf, rbgAllocationMap));
+    m_allocationMaps[params.m_sfnSf] = rbgAllocationMap;
     m_schedSapUser->SchedUlConfigInd(ret);
 }
 
@@ -1663,7 +1648,7 @@
             if (it == m_ceBsrRxed.end())
             {
                 // create the new entry
-                m_ceBsrRxed.insert(std::pair<uint16_t, uint32_t>(rnti, buffer));
+                m_ceBsrRxed[rnti] = buffer;
             }
             else
             {
@@ -1733,11 +1718,9 @@
                         newCqi.push_back(NO_SINR);
                     }
                 }
-                m_ueCqi.insert(
-                    std::pair<uint16_t, std::vector<double>>((*itMap).second.at(i), newCqi));
+                m_ueCqi[(*itMap).second.at(i)] = newCqi;
                 // generate correspondent timer
-                m_ueCqiTimers.insert(
-                    std::pair<uint16_t, uint32_t>((*itMap).second.at(i), m_cqiTimersThreshold));
+                m_ueCqiTimers[(*itMap).second.at(i)] = m_cqiTimersThreshold;
             }
             else
             {
@@ -1779,9 +1762,9 @@
                 NS_LOG_INFO(this << " RNTI " << rnti << " new SRS-CQI for RB  " << j << " value "
                                  << sinr);
             }
-            m_ueCqi.insert(std::pair<uint16_t, std::vector<double>>(rnti, newCqi));
+            m_ueCqi[rnti] = newCqi;
             // generate correspondent timer
-            m_ueCqiTimers.insert(std::pair<uint16_t, uint32_t>(rnti, m_cqiTimersThreshold));
+            m_ueCqiTimers[rnti] = m_cqiTimersThreshold;
         }
         else
         {
